"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var extractLeadingComment_1 = __importDefault(require("../utils/extractLeadingComment"));
function slotHandler(documentation, templateAst, options) {
    if (templateAst.tag === 'slot') {
        var bindings = extractAndFilterAttr(templateAst.attrsMap);
        var name_1 = 'default';
        if (bindings.name) {
            name_1 = bindings.name;
            delete bindings.name;
        }
        var slotDescriptor = documentation.getSlotDescriptor(name_1);
        if (bindings && Object.keys(bindings).length) {
            slotDescriptor.scoped = true;
        }
        slotDescriptor.bindings = bindings;
        var comment = extractLeadingComment_1.default(templateAst.parent, templateAst, options.rootLeadingComment);
        if (comment.length && comment.search(/@slot/) !== -1) {
            slotDescriptor.description = comment.replace('@slot', '').trim();
        }
    }
}
exports.default = slotHandler;
var dirRE = /^(v-|:|@)/;
var allowRE = /^(v-bind|:)/;
function extractAndFilterAttr(attrsMap) {
    var res = {};
    var keys = Object.keys(attrsMap);
    for (var _i = 0, keys_1 = keys; _i < keys_1.length; _i++) {
        var key = keys_1[_i];
        if (!dirRE.test(key) || allowRE.test(key)) {
            res[key.replace(allowRE, '')] = attrsMap[key];
        }
    }
    return res;
}
